% EXIT function for a UEC used as an outer code
% Copyright (C) 2008  Robert G. Maunder

% This program is free software: you can redistribute it and/or modify it
% under the terms of the GNU General Public License as published by the
% Free Software Foundation, either version 3 of the License, or (at your
% option) any later version.

% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
% Public License for more details.

% The GNU General Public License can be seen at http://www.gnu.org/licenses/.


% dist                 % distribution of the source bits
% s                    % parameter in the distribution
% codewords            % codewords of the trellis
% frame_count          % number of iterations for every point
% IA_count             % number of points in EXIT chart
% new_maxstar_mode
% bec                  % bec = 1:generate_bec_llrs; bec = 0:generate_llrs

function results = main_adptuec_ser_zeta_perfect(snr_start, job_index, rngNum)

global acs
global maxstar_mode
new_maxstar_mode = 0;
acs = 0;
maxstar_mode = new_maxstar_mode;

codewords = [0 0; 0 1];
%

% memory_len = str2double(memory_len); % 0: No priori information; 1,2,...,30: Actual memory length; inf: Perfect knowledge.
snr_start  = str2double(snr_start);
job_index  = str2double(job_index);

if job_index == 1
    desired_p1 = 0.8;
    sigma      = 0.0333;
    frames_per_cycle              = 20;
    standard_deviation_normaliser = 0.3097;
    m = 1000;
    
elseif job_index == 2
    desired_p1 = 0.8;
    sigma      = 0.0333;
    frames_per_cycle              = 40;
    standard_deviation_normaliser = 0.2186;
    m = 1000;
        
elseif job_index == 4
    desired_p1 = 0.85;
    sigma      = 0.0333;
    frames_per_cycle              = 40;
    standard_deviation_normaliser = 0.2186;
    m = 1000;
    
elseif job_index == 5
    desired_p1 = 0.75;
    sigma      = 0.0333;
    frames_per_cycle              = 40;
    standard_deviation_normaliser = 0.2186;
    m = 1000;
        
elseif job_index == 7
    desired_p1 = 0.8;
    sigma      = 0.05;
    frames_per_cycle              = 40;
    standard_deviation_normaliser = 0.2186;
    m = 1000;
elseif job_index == 8
    desired_p1 = 0.8;
    sigma      = 0.0333;
    frames_per_cycle              = 160;
    standard_deviation_normaliser = 0.1097;
    m = 1000;

elseif job_index == 10
    desired_p1 = 0.8;
    sigma      = 0.01667;
    frames_per_cycle              = 40;
    standard_deviation_normaliser = 0.2186;
    m = 1000;
    
else
    
end
% ===============================
% s = zeta_p1_to_s(p1);
% =====================================
[r_state, n_length] = size(codewords);
r_state = 2*r_state;
% target simulations parameters
target_frame_errors = 1000000;
iteration_count = 41;
chances = 30;
% % =====================================
% if isequal(dist,'distgeo')
%     l = average_unary_length_geo(s);
% elseif isequal(dist,'distzeta')
%     l = average_unary_length_zeta(s);
% else
%     l = average_unary_length(dist,s, 0.0000000001);
% end
% p_vec = feval(dist,1:size(codewords,1)-1,s);


rngNum = str2double(rngNum);
pause(rngNum);
rng('shuffle');

% loop over the Eb/N0 values
for snr_index = 1%1:length(snrs)
    
    % Current snr
    snr = snr_start;
    % Convert from SNR (in dB) to noise power spectral density
    N0 = 1/(10^(snr/10));
    
    %     % Create a figure to plot the results.
    %     figure
    %     axes1 = axes('YScale','log');
    %     ylabel('SER');
    %     xlabel('SNR (in dB)');
    %     xlim([snrs(1), snrs(end)]);
    %     ylim([1e-6,1]);
    %     hold on
    %     plots = plot(nan,'Parent',axes1);
    
    datestamp = datestr(now, '_yymmddHHMMSS_');
    randstamp = num2str(floor(rand(1)*10000));
    filename = ['/home/wz4g11/matlab/UEC/4th_adap_arithmatic/adapUEC/ser/v15_memory_nonstationary_p1s_urc1_complexity_memorylen/Results/job', num2str(job_index), '/results_adptuec_perfect_job', num2str(job_index), '_', num2str(m), '_snr_', num2str(snr_start), datestamp, randstamp, '.mat'];
    
    % initialization
    frame_index = 1;
    % Counters to store the number of bits and errors simulated so far
    symbol_counts = 0;
    symbol_errors = 0;
    frame_error_counts = 0;
    symbol_error_counts = zeros(1, iteration_count);
    
    %     % 1,2,...,30: Actual memory length 1k, 2k, ..., 30k
    %     % structure of p_vec: [p1,p2,p3,...]
    %     p_vec = zeros(1, size(codewords,1)-1);
    %     % memory of storing symbols recoverred
    %     symbol_mac = zeros(memory_len, m);
    
    % filter
    filter_order = 10*frames_per_cycle;
    B = fir1(filter_order, 2/frames_per_cycle); %
    hd = dfilt.dffir(B);
    hd.persistentmemory = true;
    hd.state = randn(1,filter_order);
    %
    
    % Continue the simulation until enough frame errors or bits have been simulated
    while frame_error_counts < target_frame_errors
        
        % desired_standard_deviation = 1/30
        % standard_deviation_normaliser = 0.4379
        % desired_mean = 0.797
        bool_corret_p1 = 0;
        while (~bool_corret_p1)
            
            new_data = randn;
            new_data = sigma/standard_deviation_normaliser*filter(hd, new_data) + desired_p1;
            
            if new_data <= desired_p1+3*sigma && new_data >= desired_p1-3*sigma
                
                p1 = new_data;
                s = zeta_p1_to_s(p1);
                bool_corret_p1 = 1;
            end
        end
        %
        
        % =====================================
        zeta_s = zeta(s);
        l = average_unary_length_zeta(s, zeta_s);
        p_vec = feval('distribution_zeta',1:size(codewords,1)-1,s, zeta_s);
        
        % check whether the length of p is an even number
        w_even = 0;
        % Generate some random bits
        x = generate_symbols(m, s);
        
        % Unary encoder
        y = unary_encoder(x);
        % Tellis encoder
        z = trellis_encoder(y, codewords);
        % Re-shape
        z_vec = reshape(z, 1, []);
        
        % interleaver1
        interleaver1 = randperm(length(z_vec));
        u = z_vec(interleaver1);
        
        % URC encoder
        v = URC1_encoder(u);
        
        % interleaver2
        interleaver2 = randperm(length(v));
        w = v(interleaver2);
        
        % check whether the length of p is an even number
        if mod(length(w),2) == 1
            w = [w 0];
            w_even = 1;
        end
        
        % modulation
        p = reshape(w, 2, []);
        q = modulate(p);
        
        % Rayleigh channel
        channel = sqrt(1/2) * (randn(size(q)) + 1i*randn(size(q)));
        % Received symbols with noise
        q_rx = channel.*q + sqrt(N0/2) * (randn(size(q)) + 1i*randn(size(q)));
        
        % QPSK Demodulate
        p_tilde = soft_demodulate(q_rx, channel, N0);
        % Re-shape
        w_tilde = reshape(p_tilde, 1, []);
        
        % check whether the length of p is an even number
        if 1 == w_even
            w_tilde(end) = [];
        end
        
        % deinterleaver2
        v_tilde = zeros(size(v));
        v_tilde(interleaver2) = w_tilde;
        
        z_vec_tilde_e = zeros(size(z_vec));
        z_vec_tilde_a = zeros(size(z_vec));
        
        %         % update p_vec
        %         if 1 == frame_index
        %             % average length l in current frame
        %             l = length(y)/m;
        %             % load the average length l that corresponds to different p
        %             load('l_ave.mat');
        %             [temp, l_ind] = min(abs(l_ave - l));
        %             %
        %             p1_l_est = 0.609:0.001:0.999;
        %             p1_l = p1_l_est(l_ind);
        %             % convert p1 to s, then s to p1_vector
        %             s_temp = zeta_p1_to_s(p1_l);
        %             p_vec = feval(dist, 1:size(codewords,1)-1, s_temp);
        %         else
        %             % see if the memory is already filled or not
        %             if frame_index < (memory_len + 1)
        %                 symbolsinMemory = frame_index;
        %             else
        %                 symbolsinMemory = memory_len;
        %             end
        %             % total number of symbols so far
        %             symbols_cur = symbolsinMemory*m;
        %             % count the first memory_len number of symbol values in memory
        %             for i = 1:1:(size(codewords,1)-1)
        %                 p_vec(i) = sum(sum(symbol_mac == i)) / (symbols_cur);
        %             end
        %             % average length l
        %             l = sum(sum(symbol_mac)) / (symbols_cur);
        %         end
        
        %
        best_IE = 0;
        chance  = 0;
        iteration_index = 1;
        
        % iterations start
        while iteration_index < iteration_count && chance < chances
            
            % interleaver1
            u_tilde_a = z_vec_tilde_e(interleaver1);
            
            %
            u_tilde_a(u_tilde_a == inf)  = 9000;
            u_tilde_a(u_tilde_a == -inf) = -9000;
            
            % URC decoder
            %             u_tilde_e1 = URC1_decoder(v_tilde, u_tilde_a);
            %             [u_tilde_e,~]=bcjr_decoder(u_tilde_a,v_tilde,'urc8');
            
            trans2 = [1,          1,          0,          0, 0;
                1,          2,          1,          1, 0;
                2,          2,          0,          1, 0;
                2,          1,          1,          0, 0];
            [u_tilde_e, ytildep] = bcjr_decoder(u_tilde_a, v_tilde, 'uec', trans2);            
            
            % deinterleaver1
            z_vec_tilde_a(interleaver1) = u_tilde_e;
            % Re-shape
            z_tilde_a = reshape(z_vec_tilde_a, size(z));
            
            % Do the Trellis deocder
            %             [z_tilde_e1, b_tilde_e1, acs_c1, acs_b1] = trellis_decoder_bcjr_acs(z_tilde_a, codewords, p_vec, l, m);
            transitions_uec1 = gen_uec_transitions(codewords, p_vec, l );
            
            [b_tilde_e, z_tilde_e] = bcjr_decoder(zeros(1,length(z_tilde_a)),z_tilde_a,'uec',transitions_uec1,mod(m,2)+1);
            b_tilde_e = -b_tilde_e;
            
            %             if (sum(abs(z_tilde_e1(:,1:end-3) - z_tilde_e(:,1:end-3)))>0.1)
            %                 error('somethings wrong 1');
            %             end
            %
            %             if (sum(abs(b_tilde_e1(:,1:end-3) - b_tilde_e(:,1:end-3)))>0.1)
            %                 error('somethings wrong 1');
            %             end
            
            % Re-shape
            z_vec_tilde_e = reshape(z_tilde_e, 1, []);
            
            % Soft unary decoder
            x_hat = unary_decoder_soft(b_tilde_e, m);
            
            % count the errors
            errors = sum(x_hat ~= x);
            
            % determine to stop decoding or not
            if errors == 0
                % stop iteration once get the 0 errors
                best_errors = 0;
                chance = chances;
            else
                % Have we seen an improvement in this iteration?
                IE_temp = measure_mutual_information_averaging(z_tilde_e);
                if IE_temp >  best_IE
                    best_IE = IE_temp;
                    best_errors = errors;
                else
                    chance = chance + 1;
                end
            end
            % errors remaining after each iteration
            symbol_error_counts(iteration_index) = symbol_error_counts(iteration_index) + errors;
            
            % Ready for next iteration
            iteration_index = iteration_index + 1;
        end
        
        % If iterative decoding was stopped early, assume that the same BER would have been obtained for all subsequent decoding iterations
        while iteration_index <= iteration_count
            symbol_error_counts(iteration_index) = symbol_error_counts(iteration_index) + best_errors;
            iteration_index = iteration_index + 1;
        end
        
        % if cannot correctly decoding within iterations
        if best_errors ~= 0
            % total number of errors for this frame
            symbol_errors = symbol_errors + best_errors;
            % Accumulate the number of errors that have been simulated so far
            frame_error_counts = frame_error_counts + 1;
        end
        
        % total number of symbols
        symbol_counts = symbol_counts + m;
        
        % Store the SNR and BERs in a matrix and display it.
        results(snr_index,1) = snr;
        results(snr_index,2) = symbol_counts;
        results(snr_index,3) = symbol_errors;
        results(snr_index,4) = frame_index;
        results(snr_index,5) = frame_error_counts;
        results(snr_index,(1:iteration_count)+5) = symbol_error_counts;
        
        %         % update the corresponding row of symbol_mac and p_vec
        %         row_cur = mod(frame_index, memory_len) + 1;
        %         symbol_mac(row_cur, :) = x_hat;
        
        % for next frame
        frame_index = frame_index + 1;
        
        %         % Plot the BER vs Eb/N0 results
        %         set(plots,'XData',snrs);
        %         set(plots,'YData',symbol_error_counts./symbol_counts);
        %         drawnow
        % Save the results in a file
        save(filename, 'results', '-MAT');
    end
end


